#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct proizvod {
	int sifra;
	char naziv[20];
	double cijena;
} PROIZVOD;

typedef struct cvor* PCVOR;
typedef struct cvor {
	PROIZVOD podatak;
	PCVOR sledeci;
} CVOR;

void ubaci(PCVOR* glava, PCVOR* rep, PROIZVOD proizvod);
int postoji(PCVOR glava, PROIZVOD proizvod);
void prikazi_listu(PCVOR glava);
void prikazi_proizvod(PROIZVOD proizvod);
void sacuvaj_u_dat(PCVOR glava, char* putanja);
void prikazi_datoteku(char* putanja);
void ucitaj_iz_dat_u_lst(PCVOR* glava, PCVOR* rep, char* putanja);
void izvjestaj(PCVOR glava, char* putanja);

int main(){
	//unos proizvoda
	//proizvodi se medjusobno razlikuju po sifri
	PCVOR glava;
	PCVOR rep;

	glava = NULL;
	rep = NULL;
	
	ucitaj_iz_dat_u_lst(&glava, &rep, "C:\\cdat\\Proizvodi.dat");
	izvjestaj(glava, "C:\\cdat\\Izvjestaj.txt");

	//int n;
	//printf("Koliko zelis proizvoda? ");
	//scanf("%d", &n);

	//for (int i = 0; i < n; i++) {
	//	PROIZVOD proizvod;
	//	//Unesi podatke o proizvodu
	//	printf("\nUnesi sifru ");
	//	scanf("%d", &proizvod.sifra);
	//	getchar();
	//	printf("\nUnesi naziv ");
	//	gets(proizvod.naziv);
	//	printf("\nUnesi cijenu ");
	//	scanf("%lf", &proizvod.cijena);

	//	ubaci(&glava, &rep, proizvod);
	//}
	//
	//prikazi_listu(glava);

	//sacuvaj_u_dat(glava, "C:\\cdat\\Proizvodi.dat");
	//printf("\nSadrzaj datoteke je: ");
	//prikazi_datoteku("C:\\cdat\\Proizvodi.dat");

	
	system("pause");
	return 0;
}
//Ubacuje na kraj
void ubaci(PCVOR* glava, PCVOR* rep, PROIZVOD proizvod) {
	//printf("\nProzivod koji ce biti ubacen je %5d %30s %5lf", proizvod.sifra, proizvod.naziv, proizvod.cijena);
	if (postoji(*glava, proizvod)==1) {//moze i bez ==1 
		printf("Postoji, nece biti ubacen!!!");
		return;
	}
	else {
		PCVOR novi = (PCVOR)malloc(sizeof(CVOR));
		novi->podatak = proizvod;
		novi->sledeci = NULL;
		if (*glava == NULL) {
			*glava = novi;
			//*rep = novi;
		}
		else {
			(*rep)->sledeci = novi;
			//*rep = novi;
		}

		*rep = novi;
	}
}

int postoji(PCVOR glava, PROIZVOD proizvod) {
	PCVOR tekuci = glava;
	while (tekuci != NULL) { 
		//Za poredjenje stringova se koristi strcmp
		if (tekuci->podatak.sifra == proizvod.sifra) return 1;
		tekuci = tekuci->sledeci;
	}
	return 0;
}

void prikazi_listu(PCVOR glava) {
	PCVOR tekuci = glava;
	while (tekuci != NULL) {
		prikazi_proizvod(tekuci->podatak);
		tekuci = tekuci->sledeci;
	}
}

void prikazi_proizvod(PROIZVOD proizvod) {
	printf("\n%5d %30s %5lf", proizvod.sifra, proizvod.naziv, proizvod.cijena);
}

void sacuvaj_u_dat(PCVOR glava, char* putanja) {
	FILE* datoteka;
	datoteka = fopen(putanja, "wb");//"wb" Rezim upisivanja u binarnu datoteku
	if (datoteka != NULL) {
		PCVOR tekuci = glava;
		while (tekuci != NULL) {
			PROIZVOD p = tekuci->podatak;
			fwrite(&p, sizeof(PROIZVOD), 1, datoteka); //ovo 1 oznacava koliko trenutno proizvoda unosim
			tekuci = tekuci->sledeci;
		}
		fclose(datoteka);
	}
	else {
		printf("Problem prilikom pristupa datoteci ");
	}

}

void prikazi_datoteku(char* putanja) {
	FILE* datoteka;
	datoteka = fopen(putanja, "rb"); //"rb" je rezim citanja bin dat
	if (datoteka != NULL) {
		PROIZVOD p;
		while (fread(&p, sizeof(PROIZVOD), 1, datoteka)!=0){ //fread vraca koliko je bajtova procitano
			prikazi_proizvod(p);
		}
		fclose(datoteka);
	}
	else
	{
		printf("Nije otvorena datoteka, bila je greska ");
	}
}

void ucitaj_iz_dat_u_lst(PCVOR* glava, PCVOR* rep, char* putanja) {
	FILE* datoteka;
	datoteka = fopen(putanja, "rb");
	if (datoteka != NULL) {
		PROIZVOD p;
		while (fread(&p, sizeof(PROIZVOD), 1, datoteka) != 0) {
			ubaci(glava, rep, p);
		}

		fclose(datoteka);
	}
	else {
		printf("\nFile %s ne postoji\n", putanja);
	}
}

void izvjestaj(PCVOR glava, char* putanja) {
	FILE* datoteka;
	char linija[50] = "----------------------------------------------";
	datoteka = fopen(putanja, "w");
	if (datoteka != NULL) {
		fprintf(datoteka, linija);
		fprintf(datoteka, "\nPROIZVODI\n");
		fprintf(datoteka, linija);
		fprintf(datoteka, "\n%5s %10s %30s %10s", "RB", "Sifra", "Naziv", "Cijena");
		PCVOR tekuci = glava;
		int i = 0;
		while (tekuci!=NULL){
			fprintf(datoteka, "\n%5d %10d %30s %10lf", ++i, tekuci->podatak.sifra, tekuci->podatak.naziv, tekuci->podatak.cijena);
			tekuci = tekuci->sledeci;
		}
		fprintf(datoteka, "\n");
		fprintf(datoteka, linija);
		fprintf(datoteka, "\nUkupno: %d", i);
		fclose(datoteka);
	}
	else {
		printf("\nProblem sa fajlom %s", putanja);
	}
}






